--
-- Speed comparison
--
-- My results show that in general these routines
-- are of comparable speed to rand()'s. But when compiling
-- using EC they become a little more than two times faster!!!
--
-- Juan Reina Oct 2004
--

include MTasm.e
include machine.e


--variables
atom time1,out
integer iterations

-------------MAIN-----------------
InitMT(4397)
--TRandomInit(43434)

iterations = 1E7


printf(1,"\nGenerating %d FLOATING random numbers\n",{iterations})

time1 = time()
for i = 1 to iterations do out = J_TRandom() end for
printf(1,"Mersenne Twister J_TRandom, Time Elapsed = %f sec\n",{time()-time1})


time1 = time()
for i = 1 to iterations do out = rand(10000)/10000 end for
printf(1,"Euphoria's Rand, Time Elapsed = %f sec\n",{time()-time1})


time1 = time()
for i = 1 to iterations do out = TRandom() end for
printf(1,"Mersenne Twister TRandom, Time Elapsed = %f sec\n",{time()-time1})



printf(1,"\nGenerating %d INTEGER random numbers\n",{iterations})

time1 = time()
for i = 1 to iterations do out = rand(10000) end for
printf(1,"Euphoria's Rand, Time Elapsed = %f secs\n",{time()-time1})

time1 = time()
for i = 1 to iterations do out = TIRandom(0,9999) end for
printf(1,"Mersenne Twister TIRandom, Time Elapsed = %f secs\n",{time()-time1})

Free_MT()


